import { set_t } from "./set";
export declare class category_t<O, A> {
    readonly objects: set_t<O>;
    readonly arrows: set_t<A>;
    readonly dom: (f: A) => O;
    readonly cod: (f: A) => O;
    readonly id: (x: O) => A;
    readonly compose: (f: A, g: A) => A;
    constructor(the: {
        objects: set_t<O>;
        arrows: set_t<A>;
        dom: (f: A) => O;
        cod: (f: A) => O;
        id: (x: O) => A;
        compose: (f: A, g: A) => A;
    });
    id_left(f: A): void;
    id_right(f: A): void;
    assoc(f: A, g: A, h: A): void;
}
export declare class functor_t<LO, LA, RO, RA> {
    readonly lcat: category_t<LO, LA>;
    readonly rcat: category_t<RO, RA>;
    readonly map: (x: LO) => RO;
    readonly fmap: (f: LA) => RA;
    constructor(the: {
        lcat: category_t<LO, LA>;
        rcat: category_t<RO, RA>;
        map: (x: LO) => RO;
        fmap: (f: LA) => RA;
    });
    fmap_respect_compose(f: LA, g: LA): void;
    fmap_respect_id(x: LO): void;
}
export declare class natural_transformation_t<LO, LA, RO, RA> {
    readonly lcat: category_t<LO, LA>;
    readonly rcat: category_t<RO, RA>;
    readonly lfun: functor_t<LO, LA, RO, RA>;
    readonly rfun: functor_t<LO, LA, RO, RA>;
    readonly component: (x: LO) => RA;
    constructor(the: {
        lfun: functor_t<LO, LA, RO, RA>;
        rfun: functor_t<LO, LA, RO, RA>;
        component: (x: LO) => RA;
    });
    natural(f: LA): void;
}
export declare class groupoid_t<O, A> extends category_t<O, A> {
    readonly inv: (f: A) => A;
    constructor(the: {
        objects: set_t<O>;
        arrows: set_t<A>;
        dom: (f: A) => O;
        cod: (f: A) => O;
        id: (x: O) => A;
        compose: (f: A, g: A) => A;
        inv: (f: A) => A;
    });
    arrow_iso(f: A): void;
}
