import { abelian_group_t } from "./group";
import { field_t, ring_t } from "./ring";
export declare class module_t<R, V> {
    ring: ring_t<R>;
    vector: abelian_group_t<V>;
    scale: (a: R, x: V) => V;
    constructor(the: {
        ring: ring_t<R>;
        vector: abelian_group_t<V>;
        scale: (a: R, x: V) => V;
    });
    add(x: V, y: V): V;
    eq(x: V, y: V): boolean;
    get id(): V;
    neg(x: V): V;
    ring_id_action(x: V): void;
    ring_action(a: R, b: R, x: V): void;
    vector_add_distr(a: R, x: V, y: V): void;
    ring_add_distr(a: R, b: R, x: V): void;
}
export declare class vector_space_t<R, V> extends module_t<R, V> {
    field: field_t<R>;
    constructor(the: {
        field: field_t<R>;
        vector: abelian_group_t<V>;
        scale: (a: R, x: V) => V;
    });
}
