"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const set_1 = require("./set");
class module_t {
    constructor(the) {
        this.ring = the.ring;
        this.vector = the.vector;
        this.scale = the.scale;
    }
    add(x, y) { return this.vector.add(x, y); }
    eq(x, y) { return this.vector.elements.eq(x, y); }
    get id() { return this.vector.id; }
    neg(x) { return this.vector.neg(x); }
    ring_id_action(x) {
        set_1.eqv(this.vector.elements, this.scale(this.ring.one, x), x);
    }
    ring_action(a, b, x) {
        set_1.eqv(this.vector.elements, this.scale(a, this.scale(b, x)), this.scale(this.ring.mul(a, b), x));
    }
    vector_add_distr(a, x, y) {
        set_1.eqv(this.vector.elements, this.scale(a, this.add(x, y)), this.add(this.scale(a, x), this.scale(a, y)));
    }
    ring_add_distr(a, b, x) {
        set_1.eqv(this.vector.elements, this.scale(this.ring.add(a, b), x), this.add(this.scale(a, x), this.scale(b, x)));
    }
}
exports.module_t = module_t;
class vector_space_t extends module_t {
    constructor(the) {
        super({
            ...the,
            ring: the.field,
        });
        this.field = the.field;
    }
}
exports.vector_space_t = vector_space_t;
//# sourceMappingURL=module.js.map