import { set_t } from "./set";
import { abelian_group_t, monoid_t } from "./group";
export declare class ring_t<R> {
    elements: set_t<R>;
    addition: abelian_group_t<R>;
    multiplication: monoid_t<R>;
    constructor(the: {
        addition: abelian_group_t<R>;
        multiplication: monoid_t<R>;
    });
    get zero(): R;
    add(x: R, y: R): R;
    neg(x: R): R;
    sub(x: R, y: R): R;
    get one(): R;
    mul(x: R, y: R): R;
    eq(x: R, y: R): boolean;
    zero_p(x: R): boolean;
    one_p(x: R): boolean;
    left_distr(x: R, y: R, z: R): void;
    right_distr(x: R, y: R, z: R): void;
}
export declare class commutative_ring_t<R> extends ring_t<R> {
    commu(x: R, y: R): void;
    distr(x: R, y: R, z: R): void;
}
export declare class integral_ring_t<R> extends commutative_ring_t<R> {
    nonzero_product(x: R, y: R): void;
}
export declare class euclidean_ring_t<R> extends integral_ring_t<R> {
    degree_lt: (x: R, y: R) => boolean;
    divmod: (x: R, y: R) => [R, R];
    constructor(the: {
        addition: abelian_group_t<R>;
        multiplication: monoid_t<R>;
        degree_lt: (x: R, y: R) => boolean;
        divmod: (x: R, y: R) => [R, R];
    });
    degree_lte(x: R, y: R): boolean;
    degree_gt(x: R, y: R): boolean;
    degree_gte(x: R, y: R): boolean;
    euclidean_divmod(x: R, y: R): void;
    div(x: R, y: R): R;
    mod(x: R, y: R): R;
    gcd(x: R, y: R): R;
    gcd_ext(x: R, y: R): [R, [R, R]];
    gcd_ext_p(x: R, y: R, res: [R, [R, R]]): boolean;
}
export declare class field_t<R> extends integral_ring_t<R> {
    inv: (x: R) => R;
    constructor(the: {
        addition: abelian_group_t<R>;
        multiplication: monoid_t<R>;
        inv: (x: R) => R;
    });
    div(x: R, y: R): R;
}
