"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const assert_1 = __importDefault(require("assert"));
class set_t {
    constructor(the) {
        this.eq = the.eq;
    }
}
exports.set_t = set_t;
/**
 * Due to the lack of dependent type,
 * [[eqv_t]] is implemented as runtime test generator.
 */
class eqv_t {
    constructor(set, lhs, rhs) {
        this.set = set;
        this.lhs = lhs;
        this.rhs = rhs;
    }
    check() {
        assert_1.default(this.set.eq(this.lhs, this.rhs));
    }
}
exports.eqv_t = eqv_t;
function eqv(set, lhs, rhs) {
    new eqv_t(set, lhs, rhs).check();
}
exports.eqv = eqv;
class not_eqv_t {
    constructor(set, lhs, rhs) {
        this.set = set;
        this.lhs = lhs;
        this.rhs = rhs;
    }
    check() {
        assert_1.default(!this.set.eq(this.lhs, this.rhs));
    }
}
exports.not_eqv_t = not_eqv_t;
function not_eqv(set, lhs, rhs) {
    new not_eqv_t(set, lhs, rhs).check();
}
exports.not_eqv = not_eqv;
// TODO
// the following definition is not useful.
// maybe we can not formalize sub object relation in ts.
class subset_t {
    constructor(the) {
        this.set = the.set;
        this.in = the.in;
    }
}
exports.subset_t = subset_t;
//# sourceMappingURL=set.js.map