"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const assert_1 = __importDefault(require("assert"));
const set_1 = require("./set");
// TODO
// the following definition is not useful.
// because we can not define the category_t of all group_t
// because the objects should be
//   the set of all `group_t`
//   instead of the set of `group_t <G>` for some the `G`
class category_t {
    constructor(the) {
        this.objects = the.objects;
        this.arrows = the.arrows;
        this.dom = the.dom;
        this.cod = the.cod;
        this.id = the.id;
        this.compose = (f, g) => {
            set_1.eqv(this.objects, this.cod(f), this.dom(g));
            return the.compose(f, g);
        };
    }
    id_left(f) {
        set_1.eqv(this.arrows, this.compose(this.id(this.dom(f)), f), f);
    }
    id_right(f) {
        set_1.eqv(this.arrows, this.compose(f, this.id(this.cod(f))), f);
    }
    assoc(f, g, h) {
        set_1.eqv(this.arrows, this.compose(this.compose(f, g), h), this.compose(f, this.compose(g, h)));
    }
}
exports.category_t = category_t;
class functor_t {
    constructor(the) {
        this.lcat = the.lcat;
        this.rcat = the.rcat;
        this.map = the.map;
        this.fmap = (f) => {
            let g = the.fmap(f);
            set_1.eqv(the.rcat.objects, the.map(the.lcat.dom(f)), the.rcat.dom(g));
            set_1.eqv(the.rcat.objects, the.map(the.lcat.cod(f)), the.rcat.cod(g));
            return g;
        };
    }
    fmap_respect_compose(f, g) {
        set_1.eqv(this.rcat.arrows, this.fmap(this.lcat.compose(f, g)), this.rcat.compose(this.fmap(f), this.fmap(g)));
    }
    fmap_respect_id(x) {
        set_1.eqv(this.rcat.arrows, this.fmap(this.lcat.id(x)), this.rcat.id(this.map(x)));
    }
}
exports.functor_t = functor_t;
class natural_transformation_t {
    constructor(the) {
        // note the use of === here
        assert_1.default(the.lfun.lcat === the.rfun.lcat);
        assert_1.default(the.lfun.rcat === the.rfun.rcat);
        this.lcat = the.lfun.lcat;
        this.rcat = the.lfun.rcat;
        this.lfun = the.lfun;
        this.rfun = the.rfun;
        this.component = (x) => {
            let c = the.component(x);
            set_1.eqv(this.rcat.objects, this.rcat.dom(c), this.lfun.map(x));
            set_1.eqv(this.rcat.objects, this.rcat.cod(c), this.rfun.map(x));
            return c;
        };
    }
    natural(f) {
        let a = this.lcat.dom(f);
        let b = this.lcat.cod(f);
        set_1.eqv(this.rcat.arrows, this.rcat.compose(this.component(a), this.rfun.fmap(f)), this.rcat.compose(this.lfun.fmap(f), this.component(b)));
    }
}
exports.natural_transformation_t = natural_transformation_t;
class groupoid_t extends category_t {
    constructor(the) {
        super(the);
        this.inv = the.inv;
    }
    // `dom` and `cod` of composition are only checked at runtime
    //   if the `eqv` can report report instead of throw error
    //   maybe we can use it as semantics of type system
    arrow_iso(f) {
        set_1.eqv(this.arrows, this.compose(f, this.inv(f)), this.id(this.dom(f)));
        set_1.eqv(this.arrows, this.compose(this.inv(f), f), this.id(this.cod(f)));
    }
}
exports.groupoid_t = groupoid_t;
//# sourceMappingURL=category.js.map