export declare abstract class game_t<P, S, C> {
    abstract choices(p: P, s: S): Array<C>;
    abstract choose(p: P, c: C, s: S): S;
    abstract win_p(p: P, s: S): boolean;
    valid_choice_p(p: P, c: C, s: S): boolean;
}
export declare abstract class play_t<P, S, C> {
    game: game_t<P, S, C>;
    init_state: S;
    init_player: P;
    players: Array<P>;
    moments: Array<{
        player: P;
        choice: C;
        state: S;
    }>;
    constructor(game: game_t<P, S, C>, init_state: S, init_player: P, players: Array<P>, moments?: Array<{
        player: P;
        choice: C;
        state: S;
    }>);
    abstract next_player(): P;
    beginning_p(): boolean;
    last_moment(): {
        player: P;
        choice: C;
        state: S;
    };
    last_player(): P;
    last_choice(): C;
    last_state(): S;
    tow_player_alternating(): P;
    winner(): P | null;
    state_log(s: S): void;
    move(p: P, c: C): void;
}
