"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const cx = __importStar(require("../cell-complex"));
class sphere_t extends cx.cell_complex_t {
    constructor() {
        super({ dim: 2 });
        this.attach_vertexes(["south", "middle", "north"]);
        this.attach_edge("south_long", ["south", "middle"]);
        this.attach_edge("north_long", ["middle", "north"]);
        this.attach_face("surf", [
            "south_long",
            "north_long",
            ["north_long", "rev"],
            ["south_long", "rev"],
        ]);
    }
}
exports.sphere_t = sphere_t;
class torus_t extends cx.cell_complex_t {
    constructor() {
        super({ dim: 2 });
        this.attach_vertex("origin");
        this.attach_edge("toro", ["origin", "origin"]);
        this.attach_edge("polo", ["origin", "origin"]);
        this.attach_face("surf", [
            "toro",
            "polo",
            ["toro", "rev"],
            ["polo", "rev"],
        ]);
    }
}
exports.torus_t = torus_t;
class klein_bottle_t extends cx.cell_complex_t {
    constructor() {
        super({ dim: 2 });
        this.attach_vertex("origin");
        this.attach_edge("toro", ["origin", "origin"]);
        this.attach_edge("cross", ["origin", "origin"]);
        this.attach_face("surf", [
            "toro",
            "cross",
            ["toro", "rev"],
            "cross",
        ]);
    }
}
exports.klein_bottle_t = klein_bottle_t;
class projective_plane_t extends cx.cell_complex_t {
    constructor() {
        super({ dim: 2 });
        this.attach_vertexes(["start", "end"]);
        this.attach_edge("left_rim", ["start", "end"]);
        this.attach_edge("right_rim", ["end", "start"]);
        this.attach_face("surf", [
            "left_rim", "right_rim",
            "left_rim", "right_rim",
        ]);
    }
}
exports.projective_plane_t = projective_plane_t;
//# sourceMappingURL=four-ways-to-glue-a-square.js.map