"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const ut = __importStar(require("./util"));
const num = __importStar(require("./num"));
/**
 * Computational Science and Engineering
 * - we will need `sparse_matrix_t`
 * - maybe we need a abstract interface for `matrix_t`
 *   to be able to represent K, C, T, B in even better ways
 */
{
    let K4 = num.matrix([
        [2, -1, 0, 0],
        [-1, 2, -1, 0],
        [0, -1, 2, -1],
        [0, 0, -1, 2],
    ]);
    let { lower, upper, permu, inver, } = K4.lower_upper_decomposition();
    lower.print();
    upper.print();
    permu.print();
    ut.log(inver);
}
{
    let C4 = num.matrix([
        [2, -1, 0, -1],
        [-1, 2, -1, 0],
        [0, -1, 2, -1],
        [-1, 0, -1, 2],
    ]);
    let { lower, upper, permu, inver, } = C4.lower_upper_decomposition();
    lower.print();
    upper.print();
    permu.print();
    ut.log(inver);
}
{
    let T4 = num.matrix([
        [1, -1, 0, 0],
        [-1, 2, -1, 0],
        [0, -1, 2, -1],
        [0, 0, -1, 2],
    ]);
    let { lower, upper, permu, inver, } = T4.lower_upper_decomposition();
    lower.print();
    upper.print();
    permu.print();
    ut.log(inver);
}
{
    let B4 = num.matrix([
        [1, -1, 0, 0],
        [-1, 2, -1, 0],
        [0, -1, 2, -1],
        [0, 0, -1, 1],
    ]);
    let { lower, upper, permu, inver, } = B4.lower_upper_decomposition();
    lower.print();
    upper.print();
    permu.print();
    ut.log(inver);
}
//# sourceMappingURL=cse.js.map