/**
 * Map with `string` as key.
 */
export declare class dic_t<K, V> {
    protected val_map: Map<string, V>;
    protected key_map: Map<string, K>;
    readonly key_to_str: (k: K) => string;
    constructor(key_to_str?: (k: K) => string);
    set(k: K, v: V): void;
    has(k: K): boolean;
    get(k: K): V;
    update_at(k: K, f: (v: V) => V): dic_t<K, V>;
    get size(): number;
    empty_p(): boolean;
    to_array(): Array<[K, V]>;
    merge_array(array: Array<[K, V]>): dic_t<K, V>;
    [Symbol.iterator](): Generator<[K, V], void, unknown>;
    entries(): Generator<[K, V], void, unknown>;
    keys(): Generator<K, void, unknown>;
    values(): Generator<V, void, unknown>;
    /**
     * Assuming `this.key_lt (that)`.
     */
    zip(that: dic_t<K, V>): Generator<[K, [V, V]], void, unknown>;
    key_array(): Array<K>;
    value_array(): Array<V>;
    copy(): dic_t<K, V>;
    key_eq(that: dic_t<K, V>): boolean;
    key_lt(that: dic_t<K, V>): boolean;
    key_lteq(that: dic_t<K, V>): boolean;
    key_gt(that: dic_t<K, V>): boolean;
    key_gteq(that: dic_t<K, V>): boolean;
}
