import { id_t, graph_t } from "../graph-info";
import * as cg from "../combinatorial-game";
import { random_bot_t } from "./bots/rand";
export declare type player_t = "blue" | "red";
export declare type color_t = "blue" | "red" | "green";
export declare class state_t {
    graph: graph_t<{}, {
        value: color_t;
    }>;
    constructor(graph?: graph_t<{}, {
        value: color_t;
    }>);
    colored_edge(start: number, end: number, color: color_t): state_t;
    blue(start: number, end: number): state_t;
    red(start: number, end: number): state_t;
    green(start: number, end: number): state_t;
}
export declare type choice_t = id_t;
export declare class game_t extends cg.game_t<player_t, state_t, choice_t> {
    choices(p: player_t, s: state_t): Array<choice_t>;
    choose(p: player_t, ch: choice_t, s: state_t): state_t;
    win_p(p: player_t, s: state_t): boolean;
}
export declare class play_t extends cg.play_t<player_t, state_t, choice_t> {
    next_player: () => player_t;
    state_log(s: state_t): void;
}
export declare let hackenbush: game_t;
export declare let random_bot: random_bot_t<player_t, state_t, number>;
export declare function new_play(bush: state_t): play_t;
