"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const graph_info_1 = require("../graph-info");
const cg = __importStar(require("../combinatorial-game"));
const rand_1 = require("./bots/rand");
class state_t {
    constructor(graph = new graph_info_1.graph_t()) {
        this.graph = graph;
    }
    // self-builder
    colored_edge(start, end, color) {
        this.graph.vertex_map.set(start, new graph_info_1.vertex_t(start, {}));
        this.graph.vertex_map.set(end, new graph_info_1.vertex_t(end, {}));
        this.graph.edge(this.graph.edge_map.size, start, end, { value: color });
        return this;
    }
    blue(start, end) {
        return this.colored_edge(start, end, "blue");
    }
    red(start, end) {
        return this.colored_edge(start, end, "red");
    }
    green(start, end) {
        return this.colored_edge(start, end, "green");
    }
}
exports.state_t = state_t;
class game_t extends cg.game_t {
    choices(p, s) {
        let array = [];
        s.graph.edge_map.forEach((edge, id) => {
            if (edge.info.value === p ||
                edge.info.value === "green")
                array.push(id);
        });
        return array;
    }
    choose(p, ch, s) {
        let graph = s.graph.copy();
        graph.edge_map.delete(ch);
        return new state_t(graph.connected_component_of_vertex(0));
    }
    win_p(p, s) {
        for (let [_id, edge] of s.graph.edge_map) {
            if (edge.info.value !== p && edge.info.value !== "green")
                return false;
        }
        return true;
    }
}
exports.game_t = game_t;
class play_t extends cg.play_t {
    constructor() {
        super(...arguments);
        this.next_player = this.tow_player_alternating;
    }
    state_log(s) {
        console.log("------");
        s.graph.edge_map.forEach((edge, id) => {
            console.log(`#${id}:`, `${edge.info.value}`, `${edge.start}`, `${edge.end}`);
        });
        console.log("------");
    }
}
exports.play_t = play_t;
exports.hackenbush = new game_t();
exports.random_bot = new rand_1.random_bot_t(exports.hackenbush);
function new_play(bush) {
    let play = new play_t(exports.hackenbush, bush, "blue", ["blue", "red"]);
    return play;
}
exports.new_play = new_play;
//# sourceMappingURL=hackenbush.js.map