import * as cg from "../combinatorial-game";
import { random_bot_t } from "./bots/rand";
declare type player_t = "X" | "O";
declare type mark_t = "_" | "X" | "O";
declare type row_t = [mark_t, mark_t, mark_t];
declare type state_t = [row_t, row_t, row_t];
declare type choice_t = [number, number];
declare class game_t extends cg.game_t<player_t, state_t, choice_t> {
    choices(_p: player_t, s: state_t): Array<choice_t>;
    choose(p: player_t, ch: choice_t, s: state_t): state_t;
    win_p(p: player_t, s: state_t): boolean;
}
declare class play_t extends cg.play_t<player_t, state_t, choice_t> {
    next_player: () => player_t;
    state_log(s: state_t): void;
    draw_p(): boolean;
}
export declare let tic_tac_toe: game_t;
export declare let random_bot: random_bot_t<player_t, state_t, choice_t>;
export declare function new_play(): play_t;
export {};
