"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const _ = __importStar(require("lodash"));
const cg = __importStar(require("../combinatorial-game"));
const rand_1 = require("./bots/rand");
let empty_state = [
    ["_", "_", "_"],
    ["_", "_", "_"],
    ["_", "_", "_"],
];
class game_t extends cg.game_t {
    choices(_p, s) {
        let array = [];
        s.forEach((row, x) => {
            row.forEach((mark, y) => {
                if (s[x][y] === "_")
                    array.push([x, y]);
            });
        });
        return array;
    }
    choose(p, ch, s) {
        let s1 = _.cloneDeep(s);
        let [x, y] = ch;
        s1[x][y] = p;
        return s1;
    }
    win_p(p, s) {
        return (row_win_p(p, s) ||
            column_win_p(p, s) ||
            diagonal_win_p(p, s));
    }
}
function row_win_p(p, s) {
    return ((s[0][0] === p &&
        s[0][1] === p &&
        s[0][2] === p) ||
        (s[1][0] === p &&
            s[1][1] === p &&
            s[1][2] === p) ||
        (s[2][0] === p &&
            s[2][1] === p &&
            s[2][2] === p));
}
function column_win_p(p, s) {
    return ((s[0][0] === p &&
        s[1][0] === p &&
        s[2][0] === p) ||
        (s[0][1] === p &&
            s[1][1] === p &&
            s[2][1] === p) ||
        (s[0][2] === p &&
            s[1][2] === p &&
            s[2][2] === p));
}
function diagonal_win_p(p, s) {
    return ((s[0][0] === p &&
        s[1][1] === p &&
        s[2][2] === p) ||
        (s[0][2] === p &&
            s[1][1] === p &&
            s[2][0] === p));
}
class play_t extends cg.play_t {
    constructor() {
        super(...arguments);
        this.next_player = this.tow_player_alternating;
    }
    state_log(s) {
        let repr = "";
        s.forEach((row, x) => {
            row.forEach((mark, y) => {
                repr += `${mark} `;
            });
            repr += "\n";
        });
        console.log(repr);
    }
    draw_p() {
        for (let p of this.players) {
            if (this.game.choices(p, this.last_state()).length > 0) {
                return false;
            }
        }
        return true;
    }
}
exports.tic_tac_toe = new game_t();
exports.random_bot = new rand_1.random_bot_t(exports.tic_tac_toe);
function new_play() {
    let play = new play_t(exports.tic_tac_toe, empty_state, "O", ["O", "X"]);
    return play;
}
exports.new_play = new_play;
// brute force the winning strategy
//# sourceMappingURL=tic-tac-toe.js.map