export declare type id_t = number;
export declare class vertex_t<V> {
    id: id_t;
    info: V;
    constructor(id: id_t, info: V);
    copy(): vertex_t<V>;
    more_info<I>(info: I): vertex_t<V & I>;
}
export declare class edge_t<V, E> {
    id: id_t;
    start: id_t;
    end: id_t;
    info: E;
    constructor(id: id_t, start: id_t, end: id_t, info: E);
    copy(): edge_t<V, E>;
    more_info<I>(info: I): edge_t<V, E & I>;
}
export declare class graph_t<V, E> {
    vertex_map: Map<id_t, vertex_t<V>>;
    edge_map: Map<id_t, edge_t<V, E>>;
    constructor(vertex_map?: Map<id_t, vertex_t<V>>, edge_map?: Map<id_t, edge_t<V, E>>);
    vertex(v: id_t, info: V): graph_t<V, E>;
    edge(e: id_t, start: id_t, end: id_t, info: E): graph_t<V, E>;
    copy(): graph_t<V, E>;
    connected_vertex_set(vertex_set: Set<id_t>): Set<id_t>;
    connected_vertex_set_of_vertex(v: id_t): Set<id_t>;
    connected_vertex_p(v1: id_t, v2: id_t): boolean;
    subgraph_of_vertex_set(vertex_set: Set<id_t>): graph_t<V, E>;
    connected_component_of_vertex(v: id_t): graph_t<V, E>;
}
