"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const set_1 = require("./set");
class monoid_t {
    constructor(the) {
        this.elements = the.elements;
        this.id = the.id;
        this.mul = the.mul;
    }
    assoc(x, y, z) {
        set_1.eqv(this.elements, this.mul(this.mul(x, y), z), this.mul(x, this.mul(y, z)));
    }
    id_left(x) {
        set_1.eqv(this.elements, this.mul(this.id, x), x);
    }
    id_right(x) {
        set_1.eqv(this.elements, this.mul(x, this.id), x);
    }
}
exports.monoid_t = monoid_t;
class group_t extends monoid_t {
    constructor(the) {
        super(the);
        this.inv = the.inv;
    }
    div(x, y) {
        return this.mul(x, this.inv(y));
    }
    id_inv(x) {
        set_1.eqv(this.elements, this.mul(x, this.inv(x)), this.id);
    }
}
exports.group_t = group_t;
class abelian_group_t extends group_t {
    constructor(the) {
        super({
            ...the,
            mul: the.add,
            inv: the.neg,
        });
        this.add = the.add;
        this.neg = the.neg;
    }
    sub(x, y) { return this.div(x, y); }
    commu(x, y) {
        set_1.eqv(this.elements, this.add(x, y), this.add(y, x));
    }
}
exports.abelian_group_t = abelian_group_t;
//# sourceMappingURL=group.js.map