import * as eu from "./euclid";
import { set_t } from "./abstract/set";
export declare let ints: set_t<bigint>;
export declare function abs(x: bigint): bigint;
export declare function mod(x: bigint, y: bigint): bigint;
export declare function divmod(x: bigint, y: bigint): [bigint, bigint];
export declare function div(x: bigint, y: bigint): bigint;
export declare function abs_lt(x: bigint, y: bigint): boolean;
export declare let ring: import("./abstract/ring").euclidean_ring_t<bigint>;
export declare class matrix_t extends eu.matrix_t<bigint> {
    constructor(the: {
        buffer: Array<bigint>;
        shape: [number, number];
        strides: [number, number];
        offset?: number;
    });
    copy(): matrix_t;
    static constant(n: bigint, x: number, y: number): matrix_t;
    static zeros(x: number, y: number): matrix_t;
    static ones(x: number, y: number): matrix_t;
    static id(n: number): matrix_t;
    transpose(): matrix_t;
}
export declare function matrix(array: eu.Array2d<bigint | number | string>): matrix_t;
export declare class vector_t extends eu.vector_t<bigint> {
    constructor(the: {
        buffer: Array<bigint>;
        shape: [number];
        strides: [number];
        offset?: number;
    });
    copy(): vector_t;
    static constant(n: bigint, size: number): vector_t;
    static zeros(size: number): vector_t;
    static ones(size: number): vector_t;
}
export declare function vector(array: eu.Array1d<bigint | number | string>): vector_t;
