"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const assert_1 = __importDefault(require("assert"));
const ut = __importStar(require("./util"));
function mod(x, y) {
    let m = x % y;
    if (m < 0) {
        return m + Math.abs(y);
    }
    else {
        return m;
    }
}
exports.mod = mod;
function divmod(x, y) {
    let m = mod(x, y);
    let d = (x - m) / y;
    return [d, m];
}
exports.divmod = divmod;
function div(x, y) {
    let m = mod(x, y);
    return (x - m) / y;
}
exports.div = div;
function gcd(x, y) {
    while (y !== 0) {
        if (Math.abs(y) > Math.abs(x)) {
            [x, y] = [y, x];
        }
        else {
            let r = mod(x, y);
            [x, y] = [y, r];
        }
    }
    return x;
}
exports.gcd = gcd;
function array_gcd(array) {
    return array.reduce((acc, cur) => gcd(acc, cur));
}
exports.array_gcd = array_gcd;
function gcd_ext(x, y) {
    let old_s = 1;
    let old_t = 0;
    let old_r = x;
    let s = 0;
    let t = 1;
    let r = y;
    while (r !== 0) {
        if (Math.abs(r) > Math.abs(old_r)) {
            [
                s, t, r,
                old_s, old_t, old_r,
            ] = [
                old_s, old_t, old_r,
                s, t, r,
            ];
        }
        else {
            let q = div(old_r, r);
            [old_r, r] = [r, old_r - (q * r)];
            [old_s, s] = [s, old_s - (q * s)];
            [old_t, t] = [t, old_t - (q * t)];
        }
    }
    return [old_r, [old_s, old_t]];
}
exports.gcd_ext = gcd_ext;
function gcd_ext_p(x, y, res) {
    let [d, [s, t]] = res;
    return ((gcd(x, y) === d) &&
        (s * x + t * y === d));
}
exports.gcd_ext_p = gcd_ext_p;
function array_dot(x, y) {
    assert_1.default(x.length === y.length);
    let sum = 0;
    for (let i of ut.range(0, x.length)) {
        sum += x[i] * y[i];
    }
    return sum;
}
exports.array_dot = array_dot;
function array_gcd_ext_p(array, res) {
    let [d, ext] = res;
    return ((array_gcd(array) === d) &&
        (array_dot(array, ext) === d));
}
exports.array_gcd_ext_p = array_gcd_ext_p;
function array_gcd_ext(array) {
    let ext = new Array();
    let d = array.reduce((acc, cur) => {
        let [d, [s, t]] = gcd_ext(acc, cur);
        if (ext.length === 0) {
            ext = [s, t];
        }
        else {
            ext = ext.map(x => x * s);
            ext.push(t);
        }
        return d;
    });
    return [d, ext];
}
exports.array_gcd_ext = array_gcd_ext;
//# sourceMappingURL=number.js.map