export declare class permutation_t {
    /**
     * A permutation is encoded by
     * the result of its action on [1, 2, ..., n].
     * I call this result "sequence".
     */
    readonly sequence: Array<number>;
    readonly size: number;
    constructor(sequence: Array<number>);
    get(i: number): number;
    [Symbol.iterator](): Generator<number, void, unknown>;
    pairs(): Generator<[number, number], void, unknown>;
    inv_pairs(): Generator<[number, number], void, unknown>;
    inv(): permutation_t;
    mul(that: permutation_t): permutation_t;
    eq(that: permutation_t): boolean;
    lt(that: permutation_t): boolean;
    private lt_after;
    lte(that: permutation_t): boolean;
    private lte_after;
    gt(that: permutation_t): boolean;
    gte(that: permutation_t): boolean;
    static id(size: number): permutation_t;
    tuck(i: number, j: number): permutation_t;
}
