export declare class set_t<T> {
    readonly eq: (x: T, y: T) => boolean;
    constructor(the: {
        eq: (x: T, y: T) => boolean;
    });
}
/**
 * Due to the lack of dependent type,
 * [[eqv_t]] is implemented as runtime test generator.
 */
export declare class eqv_t<T> {
    set: set_t<T>;
    lhs: T;
    rhs: T;
    constructor(set: set_t<T>, lhs: T, rhs: T);
    check(): void;
}
export declare function eqv<T>(set: set_t<T>, lhs: T, rhs: T): void;
export declare class not_eqv_t<T> {
    set: set_t<T>;
    lhs: T;
    rhs: T;
    constructor(set: set_t<T>, lhs: T, rhs: T);
    check(): void;
}
export declare function not_eqv<T>(set: set_t<T>, lhs: T, rhs: T): void;
export declare class subset_t<T> {
    readonly set: set_t<T>;
    readonly in: (x: T) => boolean;
    constructor(the: {
        set: set_t<T>;
        in: (x: T) => boolean;
    });
}
